unit backgroundWorker1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  MMSHelpers,
  OtlCommon,
  OtlParallel;

const
  WM_RETRIEVE = WM_USER;

type
  TfrmLinkRetrieval = class(TForm)
    lbLinks: TListBox;
    btnStart: TButton;
    btnStop: TButton;
    Memo1: TMemo;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    FBkGet: IOmniBackgroundWorker;
    procedure RetrievePageBk(const workItem: IOmniWorkItem);
    procedure MarkLoaded(pageNum: integer; success: boolean = true);
  public
  end;

var
  frmLinkRetrieval: TfrmLinkRetrieval;

implementation

uses
  StrUtils;

{$R *.dfm}

const
  CLinks: array [1..16] of string = ('97248', '97242', '97229', '97224', '97211',
    '97214', '97193', '97183', '97173', '97174', '97169', '97156', '97150', '97149',
    '97147', '97144');

function MakeUrl(const page: string): string;
begin
  Result := 'http://www.delphifeeds.com/go/s/' + page;
end;

procedure TfrmLinkRetrieval.btnStartClick(Sender: TObject);
var
  iLink: integer;
begin
  lbLinks.Clear;
  for iLink := Low(CLinks) to High(CLinks) do
    lbLinks.Items.Add(Format('%d=%s', [iLink, MakeUrl(CLinks[iLink])]));

  FBkGet := Parallel.BackgroundWorker;
  FBkGet.NumTasks(Environment.Process.Affinity.Count * 2);
  FBkGet.OnRequestDone(
    procedure (const Sender: IOmniBackgroundWorker;
               const workItem: IOmniWorkItem)
    begin
      Memo1.Text := workItem.Result;
      MarkLoaded(workItem.Data);
    end);
  FBkGet.Execute(RetrievePageBk);

  for iLink := Low(CLinks) to High(CLinks) do
    FBkGet.Schedule(
      FBkGet.CreateWorkItem(iLink)
    );
end;

procedure TfrmLinkRetrieval.btnStopClick(Sender: TObject);
begin
  FBkGet.Terminate(INFINITE);
  FBkGet := nil;
end;

procedure TfrmLinkRetrieval.MarkLoaded(pageNum: integer; success: boolean);
var
  iLink : integer;
  status: string;
  test  : string;
begin
  test := Format('%d=', [pageNum]);
  for iLink := 0 to lbLinks.Count - 1 do begin
    if StartsText(test, lbLinks.Items[iLink]) then begin
      if success then status := '+' else status := '!';
      lbLinks.Items[iLink] := status + lbLinks.Items[iLink];
      break; //for
    end;
  end;
end;

procedure TfrmLinkRetrieval.RetrievePageBk(const workItem: IOmniWorkItem);
var
  pageContents: string;
begin
  HttpGet('www.delphifeeds.com', 80,
    'go/s/' + CLinks[workitem.Data.AsInteger], pageContents, '');
  workItem.Result := pageContents;
end;

end.
